#version 150

#moj_import <purple_border_gui/util_functions.glsl>
#moj_import <purple_border_gui/item_selection_bitmap.glsl>

in vec4 vertexColor;
in vec4 gradientColor;
// resolution of gradient or bitmap depending on bgRenderMode
// r = vertical resolution
// g = horizontal resolution
in vec4 gradientResolution;
// 1 = crafting table text box
// 2 = slot highlight
// 3 = red slot highlight
in float renderSlotHighlight;
in vec3 cornerPos1;
in vec3 cornerPos2;
in vec3 cornerPos3;
in vec3 pos;

uniform vec4 ColorModulator;
uniform mat4 ProjMat;

out vec4 fragColor;


void main() {
    vec4 color = vertexColor;

    vec4 gradientColor2 = getGradientWithResolution(gradientColor, gradientResolution);

    // slot highlight
    if(renderSlotHighlight > 0){
        vec4 gradientColorUV = getGradientWithResolution(gradientColor, gradientResolution) * gradientResolution; // coordinates for bitmap texture
        int x = int(gradientColorUV.g);
        int y = int(gradientColorUV.r);

        for(int i = 0; i < y; i++){
            x += int(gradientResolution.x);
        }

        if(renderSlotHighlight > 2.9){
            color = slotRightClickDraggingColors[slotRightClickDraggingBitmap[x]];
        }else{
            color = slotHighlightColors[slotHighlightBitmap[x]];
        }

    }

    if (color.a == 0.0) {
        discard;
    }

    fragColor = color * ColorModulator;
}
