#version 150

#moj_import <fog.glsl>
#moj_import <purple_border_gui/util_functions.glsl>

in vec3 Position;
in vec4 Color;
in vec2 UV0;
in ivec2 UV2;

uniform sampler2D Sampler2;

uniform mat4 ModelViewMat;
uniform mat4 ProjMat;
uniform mat3 IViewRotMat;
uniform int FogShape;

out float vertexDistance;
out vec4 vertexColor;
out vec2 texCoord0;

bool inGUI() {
    // max vertex distance for text to be classed as in a gui
    float maxVertDistance = 800;

    if(fog_distance(ModelViewMat, IViewRotMat * Position, FogShape) >= maxVertDistance){
        return true;
    } else{
        return false;
    }
}

void main() {
    vec3 pos = Position;
    vec4 col = Color;

    // inventory text
    if( roughlyEquals( col.rgb, vec3(0.25098, 0.25098, 0.25098) ) ) {
        col.rgb = vec3(0.98039, 0.96078, 0.88235);
    }
    // enchanting table button text
    else if( roughlyEquals( Color.rgb, vec3(0.40784313725490196, 0.3686274509803922, 0.2901960784313726) ) && inGUI()){
        pos.y += 2;
    }
    // enchanting table button diabled text
    else if( roughlyEquals( Color.rgb, vec3(0.20392156862745098, 0.1843137254901961, 0.1450980392156863) ) && inGUI()){
        pos.y += 2;
    }
    // enchanting table button hover text
    else if( roughlyEquals( Color.rgb, vec3(1, 1, 0.5019607843137255) ) && inGUI()){
        pos.y += 1;
    }

    gl_Position = ProjMat * ModelViewMat * vec4(pos, 1.0);
    vertexDistance = fog_distance(ModelViewMat, IViewRotMat * Position, FogShape);
    vertexColor = col * texelFetch(Sampler2, UV2 / 16, 0);
    vertexColor = col;
    texCoord0 = UV0;
}
